# strings.pl - string "compiler"
#
# records are:
# label "string"
#
&init() ;
if (open(V,"<version"))  {
    $_ = scalar(<V>) ;
    ($version=$_) =~ s/[\r\n]+// ;
    close(V) ;
}
$strpre = shift ARGV ;

while (<ARGV>)  {
    if (/$strpre[ \t]+([^ \t]+)[ \t]+"(.*)"$/)  {
        $label = $1 ;
        $ostr = $2 ;
        $str = $2."\0" ;        # put in the trailing NUL
        $str =~ s/\$\$VERSION\$\$/$version/g ;
        $str =~ s/\\([rnt])/$ct{$1}/eg ;
        print "$label:\t\t; $ostr\n" ;     # label first
        for ($i=0 ; $i<length($str) ; $i+=2)  {
            printf "\t.dw 0x%04X\n",unpack("S",substr($str,$i,2)) ;
        }
    }
}

sub init  {
    %ct = (
        "r","\r",
        "n","\n",
        "t","\t"
    ) ;
}
